net.snowflake.client.jdbc

## Class SnowflakeConnectionV1

- java.lang.Object
- - net.snowflake.client.jdbc.SnowflakeConnectionV1

All Implemented Interfaces:
  AutoCloseable, Connection, Wrapper

    public class SnowflakeConnectionV1
    extends Object
    implements Connection

Snowflake connection implementation

Author:
  jhuang

### Field Summary

Fields
`protected Level` `tracingLevel`

### Fields inherited from interface java.sql.Connection

`TRANSACTION_NONE, TRANSACTION_READ_COMMITTED, TRANSACTION_READ_UNCOMMITTED, TRANSACTION_REPEATABLE_READ, TRANSACTION_SERIALIZABLE`

### Constructor Summary

Constructors
Constructor and Description
`SnowflakeConnectionV1(String url, Properties info)` A connection will establish a session token from snowflake

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`void` `abort(Executor executor)`
`void` `clearWarnings()`
`void` `close()` Close the connection
`void` `commit()`
`void` `compressAndUploadStream(String stageName, String destPrefix, InputStream inputStream, String destFileName)` Method to compress data from a stream and upload it at a stage location.
`Array` `createArrayOf(String typeName, Object[] elements)`
`Blob` `createBlob()`
`Clob` `createClob()`
`NClob` `createNClob()`
`SQLXML` `createSQLXML()`
`Statement` `createStatement()` Create a statement
`Statement` `createStatement(int resultSetType, int resultSetConcurrency)`
`Statement` `createStatement(int resultSetType, int resultSetConcurrency, int resultSetHoldability)`
`Struct` `createStruct(String typeName, Object[] attributes)`
`String` `getAccountName()`
`int` `getAndIncrementSequenceId()`
`boolean` `getAutoCommit()`
`String` `getCatalog()`
`Properties` `getClientInfo()`
`String` `getClientInfo(String name)`
`int` `getDatabaseMajorVersion()`
`int` `getDatabaseMinorVersion()`
`String` `getDatabaseVersion()`
`int` `getHoldability()`
`int` `getInjectClientPause()`
`String` `getInjectFileUploadFailure()`
`int` `getInjectSocketTimeout()`
`static int` `getMajorVersion()`
`DatabaseMetaData` `getMetaData()` Return the database metadata
`static int` `getMinorVersion()`
`int` `getNetworkTimeout()`
`String` `getNewClientForUpdate()`
`int` `getQueryTimeout()`
`String` `getSchema()`
`protected String` `getServerUrl()` get server url
`SFSession` `getSfSession()`
`Object` `getSFSessionProperty(String propertyName)`
`int` `getTransactionIsolation()`
`Map<String,Class<?>>` `getTypeMap()`
`String` `getURL()`
`String` `getUserName()`
`SQLWarning` `getWarnings()`
`boolean` `isClosed()`
`boolean` `isReadOnly()`
`boolean` `isRetryQuery()`
`boolean` `isUseV1QueryAPI()`
`boolean` `isValid(int timeout)`
`boolean` `isWrapperFor(Class<?> iface)`
`String` `nativeSQL(String sql)`
`CallableStatement` `prepareCall(String sql)`
`CallableStatement` `prepareCall(String sql, int resultSetType, int resultSetConcurrency)`
`CallableStatement` `prepareCall(String sql, int resultSetType, int resultSetConcurrency, int resultSetHoldability)`
`PreparedStatement` `prepareStatement(String sql)`
`PreparedStatement` `prepareStatement(String sql, int autoGeneratedKeys)`
`PreparedStatement` `prepareStatement(String sql, int[] columnIndexes)`
`PreparedStatement` `prepareStatement(String sql, int resultSetType, int resultSetConcurrency)`
`PreparedStatement` `prepareStatement(String sql, int resultSetType, int resultSetConcurrency, int resultSetHoldability)`
`PreparedStatement` `prepareStatement(String sql, String[] columnNames)`
`void` `releaseSavepoint(Savepoint savepoint)`
`void` `rollback()`
`void` `rollback(Savepoint savepoint)`
`void` `setAccountName(String accountName)`
`void` `setAutoCommit(boolean isAutoCommit)`
`void` `setCatalog(String catalog)`
`void` `setClientInfo(Properties properties)`
`void` `setClientInfo(String name, String value)`
`void` `setHoldability(int holdability)`
`void` `setInjectClientPause(int injectClientPause)`
`void` `setInjectedDelay(int delay)`
`void` `setInjectFileUploadFailure(String fileToFail)`
`void` `setInjectSocketTimeout(int injectSocketTimeout)`
`void` `setNetworkTimeout(Executor executor, int milliseconds)`
`void` `setNewClientForUpdate(String newClientForUpdate)`
`void` `setReadOnly(boolean readOnly)`
`void` `setRetryQuery(boolean retryQuery)`
`Savepoint` `setSavepoint()`
`Savepoint` `setSavepoint(String name)`
`void` `setSchema(String schema)`
`void` `setTransactionIsolation(int level)`
`void` `setTypeMap(Map<String,Class<?>> map)`
`void` `setUserName(String userName)`
`void` `setUseV1QueryAPI(boolean useV1QueryAPI)`
`<T> T` `unwrap(Class<T> iface)`
`void` `uploadStream(String stageName, String destPrefix, InputStream inputStream, String destFileName, long streamSize)` Method to put data from a stream at a stage location.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### tracingLevel

    protected Level tracingLevel

### Constructor Detail

#### SnowflakeConnectionV1

    public SnowflakeConnectionV1(String url,
                                 Properties info)
                          throws SQLException

A connection will establish a session token from snowflake

Parameters:
  `url` - server url used to create snowflake connection
  `info` - properties about the snowflake connection
Throws:
  `SQLException` - if failed to create a snowflake connection i.e. username or password not specified

### Method Detail

#### getNewClientForUpdate

    public String getNewClientForUpdate()

#### setNewClientForUpdate

    public void setNewClientForUpdate(String newClientForUpdate)

#### getAndIncrementSequenceId

    public int getAndIncrementSequenceId()

#### getServerUrl

    protected String getServerUrl()

get server url

Returns:
  server url

#### createStatement

    public Statement createStatement()
                              throws SQLException

Create a statement

Specified by:
  `createStatement` in interface `Connection`
Returns:
  statement
Throws:
  `SQLException` - if failed to create a snowflake statement

#### close

    public void close()
               throws SQLException

Close the connection

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `Connection`
Throws:
  `SQLException` - failed to close the connection

#### isClosed

    public boolean isClosed()
                     throws SQLException

Specified by:
  `isClosed` in interface `Connection`
Throws:
  `SQLException`

#### getMetaData

    public DatabaseMetaData getMetaData()
                                 throws SQLException

Return the database metadata

Specified by:
  `getMetaData` in interface `Connection`
Returns:
  Database metadata
Throws:
  `SQLException` - f

#### prepareCall

    public CallableStatement prepareCall(String sql)
                                  throws SQLException

Specified by:
  `prepareCall` in interface `Connection`
Throws:
  `SQLException`

#### prepareCall

    public CallableStatement prepareCall(String sql,
                                         int resultSetType,
                                         int resultSetConcurrency)
                                  throws SQLException

Specified by:
  `prepareCall` in interface `Connection`
Throws:
  `SQLException`

#### prepareCall

    public CallableStatement prepareCall(String sql,
                                         int resultSetType,
                                         int resultSetConcurrency,
                                         int resultSetHoldability)
                                  throws SQLException

Specified by:
  `prepareCall` in interface `Connection`
Throws:
  `SQLException`

#### nativeSQL

    public String nativeSQL(String sql)
                     throws SQLException

Specified by:
  `nativeSQL` in interface `Connection`
Throws:
  `SQLException`

#### setAutoCommit

    public void setAutoCommit(boolean isAutoCommit)
                       throws SQLException

Specified by:
  `setAutoCommit` in interface `Connection`
Throws:
  `SQLException`

#### getAutoCommit

    public boolean getAutoCommit()
                          throws SQLException

Specified by:
  `getAutoCommit` in interface `Connection`
Throws:
  `SQLException`

#### commit

    public void commit()
                throws SQLException

Specified by:
  `commit` in interface `Connection`
Throws:
  `SQLException`

#### rollback

    public void rollback()
                  throws SQLException

Specified by:
  `rollback` in interface `Connection`
Throws:
  `SQLException`

#### rollback

    public void rollback(Savepoint savepoint)
                  throws SQLException

Specified by:
  `rollback` in interface `Connection`
Throws:
  `SQLException`

#### setReadOnly

    public void setReadOnly(boolean readOnly)
                     throws SQLException

Specified by:
  `setReadOnly` in interface `Connection`
Throws:
  `SQLException`

#### isReadOnly

    public boolean isReadOnly()
                       throws SQLException

Specified by:
  `isReadOnly` in interface `Connection`
Throws:
  `SQLException`

#### setCatalog

    public void setCatalog(String catalog)
                    throws SQLException

Specified by:
  `setCatalog` in interface `Connection`
Throws:
  `SQLException`

#### getCatalog

    public String getCatalog()
                      throws SQLException

Specified by:
  `getCatalog` in interface `Connection`
Throws:
  `SQLException`

#### setTransactionIsolation

    public void setTransactionIsolation(int level)
                                 throws SQLException

Specified by:
  `setTransactionIsolation` in interface `Connection`
Throws:
  `SQLException`

#### getTransactionIsolation

    public int getTransactionIsolation()
                                throws SQLException

Specified by:
  `getTransactionIsolation` in interface `Connection`
Throws:
  `SQLException`

#### getWarnings

    public SQLWarning getWarnings()
                           throws SQLException

Specified by:
  `getWarnings` in interface `Connection`
Throws:
  `SQLException`

#### clearWarnings

    public void clearWarnings()
                       throws SQLException

Specified by:
  `clearWarnings` in interface `Connection`
Throws:
  `SQLException`

#### createStatement

    public Statement createStatement(int resultSetType,
                                     int resultSetConcurrency)
                              throws SQLException

Specified by:
  `createStatement` in interface `Connection`
Throws:
  `SQLException`

#### createStatement

    public Statement createStatement(int resultSetType,
                                     int resultSetConcurrency,
                                     int resultSetHoldability)
                              throws SQLException

Specified by:
  `createStatement` in interface `Connection`
Throws:
  `SQLException`

#### prepareStatement

    public PreparedStatement prepareStatement(String sql)
                                       throws SQLException

Specified by:
  `prepareStatement` in interface `Connection`
Throws:
  `SQLException`

#### prepareStatement

    public PreparedStatement prepareStatement(String sql,
                                              int autoGeneratedKeys)
                                       throws SQLException

Specified by:
  `prepareStatement` in interface `Connection`
Throws:
  `SQLException`

#### prepareStatement

    public PreparedStatement prepareStatement(String sql,
                                              int[] columnIndexes)
                                       throws SQLException

Specified by:
  `prepareStatement` in interface `Connection`
Throws:
  `SQLException`

#### prepareStatement

    public PreparedStatement prepareStatement(String sql,
                                              String[] columnNames)
                                       throws SQLException

Specified by:
  `prepareStatement` in interface `Connection`
Throws:
  `SQLException`

#### prepareStatement

    public PreparedStatement prepareStatement(String sql,
                                              int resultSetType,
                                              int resultSetConcurrency)
                                       throws SQLException

Specified by:
  `prepareStatement` in interface `Connection`
Throws:
  `SQLException`

#### prepareStatement

    public PreparedStatement prepareStatement(String sql,
                                              int resultSetType,
                                              int resultSetConcurrency,
                                              int resultSetHoldability)
                                       throws SQLException

Specified by:
  `prepareStatement` in interface `Connection`
Throws:
  `SQLException`

#### getTypeMap

    public Map<String,Class<?>> getTypeMap()
                                    throws SQLException

Specified by:
  `getTypeMap` in interface `Connection`
Throws:
  `SQLException`

#### setTypeMap

    public void setTypeMap(Map<String,Class<?>> map)
                    throws SQLException

Specified by:
  `setTypeMap` in interface `Connection`
Throws:
  `SQLException`

#### setHoldability

    public void setHoldability(int holdability)
                        throws SQLException

Specified by:
  `setHoldability` in interface `Connection`
Throws:
  `SQLException`

#### getHoldability

    public int getHoldability()
                       throws SQLException

Specified by:
  `getHoldability` in interface `Connection`
Throws:
  `SQLException`

#### setSavepoint

    public Savepoint setSavepoint()
                           throws SQLException

Specified by:
  `setSavepoint` in interface `Connection`
Throws:
  `SQLException`

#### setSavepoint

    public Savepoint setSavepoint(String name)
                           throws SQLException

Specified by:
  `setSavepoint` in interface `Connection`
Throws:
  `SQLException`

#### releaseSavepoint

    public void releaseSavepoint(Savepoint savepoint)
                          throws SQLException

Specified by:
  `releaseSavepoint` in interface `Connection`
Throws:
  `SQLException`

#### createBlob

    public Blob createBlob()
                    throws SQLException

Specified by:
  `createBlob` in interface `Connection`
Throws:
  `SQLException`

#### createClob

    public Clob createClob()
                    throws SQLException

Specified by:
  `createClob` in interface `Connection`
Throws:
  `SQLException`

#### createNClob

    public NClob createNClob()
                      throws SQLException

Specified by:
  `createNClob` in interface `Connection`
Throws:
  `SQLException`

#### createSQLXML

    public SQLXML createSQLXML()
                        throws SQLException

Specified by:
  `createSQLXML` in interface `Connection`
Throws:
  `SQLException`

#### isValid

    public boolean isValid(int timeout)
                    throws SQLException

Specified by:
  `isValid` in interface `Connection`
Throws:
  `SQLException`

#### setClientInfo

    public void setClientInfo(Properties properties)
                       throws SQLClientInfoException

Specified by:
  `setClientInfo` in interface `Connection`
Throws:
  `SQLClientInfoException`

#### setClientInfo

    public void setClientInfo(String name,
                              String value)
                       throws SQLClientInfoException

Specified by:
  `setClientInfo` in interface `Connection`
Throws:
  `SQLClientInfoException`

#### getClientInfo

    public Properties getClientInfo()
                             throws SQLException

Specified by:
  `getClientInfo` in interface `Connection`
Throws:
  `SQLException`

#### getClientInfo

    public String getClientInfo(String name)

Specified by:
  `getClientInfo` in interface `Connection`

#### createArrayOf

    public Array createArrayOf(String typeName,
                               Object[] elements)
                        throws SQLException

Specified by:
  `createArrayOf` in interface `Connection`
Throws:
  `SQLException`

#### createStruct

    public Struct createStruct(String typeName,
                               Object[] attributes)
                        throws SQLException

Specified by:
  `createStruct` in interface `Connection`
Throws:
  `SQLException`

#### setSchema

    public void setSchema(String schema)
                   throws SQLException

Specified by:
  `setSchema` in interface `Connection`
Throws:
  `SQLException`

#### getSchema

    public String getSchema()
                     throws SQLException

Specified by:
  `getSchema` in interface `Connection`
Throws:
  `SQLException`

#### abort

    public void abort(Executor executor)
               throws SQLException

Specified by:
  `abort` in interface `Connection`
Throws:
  `SQLException`

#### setNetworkTimeout

    public void setNetworkTimeout(Executor executor,
                                  int milliseconds)
                           throws SQLException

Specified by:
  `setNetworkTimeout` in interface `Connection`
Throws:
  `SQLException`

#### getNetworkTimeout

    public int getNetworkTimeout()
                          throws SQLException

Specified by:
  `getNetworkTimeout` in interface `Connection`
Throws:
  `SQLException`

#### isWrapperFor

    public boolean isWrapperFor(Class<?> iface)
                         throws SQLException

Specified by:
  `isWrapperFor` in interface `Wrapper`
Throws:
  `SQLException`

#### unwrap

    public <T> T unwrap(Class<T> iface)
                 throws SQLException

Specified by:
  `unwrap` in interface `Wrapper`
Throws:
  `SQLException`

#### getSFSessionProperty

    public Object getSFSessionProperty(String propertyName)

#### getMajorVersion

    public static int getMajorVersion()

#### getMinorVersion

    public static int getMinorVersion()

#### getDatabaseMajorVersion

    public int getDatabaseMajorVersion()

#### getDatabaseMinorVersion

    public int getDatabaseMinorVersion()

#### getDatabaseVersion

    public String getDatabaseVersion()

#### getUserName

    public String getUserName()

#### setUserName

    public void setUserName(String userName)

#### getAccountName

    public String getAccountName()

#### setAccountName

    public void setAccountName(String accountName)

#### getURL

    public String getURL()

#### getQueryTimeout

    public int getQueryTimeout()

#### uploadStream

    public void uploadStream(String stageName,
                             String destPrefix,
                             InputStream inputStream,
                             String destFileName,
                             long streamSize)
                      throws SQLException

Method to put data from a stream at a stage location. The data will be uploaded as one file. No splitting is done in this method. Stream size must match the total size of data in the input stream unless compressData parameter is set to true. caller is responsible for passing the correct size for the data in the stream and releasing the inputStream after the method is called.

Parameters:
  `stageName` - stage name: e.g. ~ or table name or stage name
  `destPrefix` - path prefix under which the data should be uploaded on the stage
  `inputStream` - input stream from which the data will be uploaded
  `destFileName` - destination file name to use
  `streamSize` - data size in the stream
Throws:
  `SQLException` - failed to put data from a stream at stage

#### compressAndUploadStream

    public void compressAndUploadStream(String stageName,
                                        String destPrefix,
                                        InputStream inputStream,
                                        String destFileName)
                                 throws SQLException

Method to compress data from a stream and upload it at a stage location. The data will be uploaded as one file. No splitting is done in this method. caller is responsible for releasing the inputStream after the method is called.

Parameters:
  `stageName` - stage name: e.g. ~ or table name or stage name
  `destPrefix` - path prefix under which the data should be uploaded on the stage
  `inputStream` - input stream from which the data will be uploaded
  `destFileName` - destination file name to use
Throws:
  `SQLException` - failed to compress and put data from a stream at stage

#### setInjectedDelay

    public void setInjectedDelay(int delay)

#### getInjectSocketTimeout

    public int getInjectSocketTimeout()

#### setInjectSocketTimeout

    public void setInjectSocketTimeout(int injectSocketTimeout)

#### isUseV1QueryAPI

    public boolean isUseV1QueryAPI()

#### setUseV1QueryAPI

    public void setUseV1QueryAPI(boolean useV1QueryAPI)

#### isRetryQuery

    public boolean isRetryQuery()

#### setRetryQuery

    public void setRetryQuery(boolean retryQuery)

#### getInjectClientPause

    public int getInjectClientPause()

#### setInjectClientPause

    public void setInjectClientPause(int injectClientPause)

#### setInjectFileUploadFailure

    public void setInjectFileUploadFailure(String fileToFail)

#### getInjectFileUploadFailure

    public String getInjectFileUploadFailure()

#### getSfSession

    public SFSession getSfSession()